﻿// SlideShow.jsx
//
// Keith Gilbert
// www.gilbertconsulting.com
// blog.gilbertconsulting.com
//
// Modified 2010-06-15

#target indesign

// Check to see whether any InDesign documents are open.
// If no documents are open, display an error message.
if (app.documents.length > 0) {
        
    // Dialog box to get desired time between slides, in seconds as well as looping options
    var params = showDialog();
    if (isFinite(params.myDelay)) {
        nextSlide(params.myDelay, params.myLoop);    
    }
}
else {
    // No documents are open, so display an error message.
    alert("Il n'y a pas de document ouvert. \rOuvrez un document et relancez le script.");
}

function pausecomp(millis) {
    var date = new Date();
    var curDate = null;
    do {
        curDate = new Date();
    } 
    while(curDate-date < millis);
} 

function showDialog() {
    // Prompt the user for parameters
    var myDialog = app.dialogs.add({name:"Diaporama", canCancel:true});
    with (myDialog) {
        with (dialogColumns.add()) {
            staticTexts.add({staticLabel:"Délai entre 2 images (en s) : "});
            staticTexts.add({staticLabel:"Boucler "});
            staticTexts.add({staticLabel:"Pour quitter le diaporama, tapez 2 fois Esc."});
            staticTexts.add({staticLabel:"Script de Keith Gilbert"});
            staticTexts.add({staticLabel:"  (francisé par Pierre Labbe)"});
        }
        with (myDialog.dialogColumns.add()) {
            var myDelayField = textEditboxes.add({editContents:"", minWidth: 40});
            var myLoopField = checkboxControls.add();
        }
    }
    if (myDialog.show() == true) { // User didn't click the cancel button
        var myDelay = myDelayField.editContents;
        var myLoop = myLoopField.checkedState;
        myDialog.destroy();
        return {myDelay:myDelay,myLoop:myLoop};
    }
    else {
        myDialog.destroy();
        return {myDelay:"x"};
    }	
}

function nextSlide(myDelay, myLoop) {
    
    // Turn on screen redraw while the script runs
    var userRedrawSetting = app.scriptPreferences.enableRedraw;
    app.scriptPreferences.enableRedraw = true;
    
    var myDoc = app.activeDocument;
    
    // Turn to first page;
    myDoc.spreads.firstItem().select();

    // Put window in Presentation mode
    app.activeWindow.screenMode = ScreenModeOptions.PRESENTATION_PREVIEW;
    
    do {
        // Turn to first page;
        myDoc.spreads.firstItem().select();
        app.activeWindow.zoom(ZoomOptions.FIT_SPREAD);
                
        // Pause
        pausecomp(myDelay*1000);
        
        app.activeWindow.zoom(ZoomOptions.FIT_SPREAD);
        
        for (var i=0; i<=myDoc.spreads.length-2; i ++) {
            try {
                var myMenuAction1 = app.menuActions.item("Planche suivante");
                myMenuAction1.invoke();        
            }
            catch (myError) {};

            // Pause
            pausecomp(myDelay*1000);     
        }
    }
    while (myLoop == true);

    // Turn screen redraw back to what it was
    app.scriptPreferences.enableRedraw = userRedrawSetting;

}